Summary: A collection of CD/DVD utilities
Name:    cdrkit
Version: 1.1.11
Release: 5%{?dist}
License: GPLv2
URL:     https://en.wikipedia.org/wiki/Cdrkit
Source0: https://dev.alpinelinux.org/archive/%{name}/%{name}-%{version}.tar.gz

Patch3000: cdrkit-1.1.8-werror.patch
Patch3001: cdrkit-1.1.9-efi-boot.patch
Patch3002: cdrkit-1.1.9-no_mp3.patch
Patch3003: cdrkit-1.1.9-buffer_overflow.patch
Patch3004: cdrkit-1.1.10-build-fix.patch
Patch3005: cdrkit-1.1.11-manpagefix.patch
Patch3006: cdrkit-1.1.11-rootstat.patch
Patch3007: cdrkit-1.1.11-usalinst.patch
Patch3008: cdrkit-1.1.11-readsegfault.patch
Patch3009: cdrkit-1.1.11-format.patch
Patch3010: cdrkit-1.1.11-handler.patch
Patch3011: cdrkit-1.1.11-dvdman.patch
Patch3012: cdrkit-1.1.11-paranoiacdda.patch
Patch3013: cdrkit-1.1.11-utf8.patch
Patch3014: cdrkit-1.1.11-cmakewarn.patch
Patch3015: cdrkit-1.1.11-memset.patch
Patch3016: cdrkit-1.1.11-ppc64le_elfheader.patch
Patch3017: cdrkit-1.1.11-werror_gcc5.patch
Patch3018: cdrkit-1.1.11-devname.patch
Patch3019: cdrkit-1.1.11-sysmacros.patch
Patch3020: cdrkit-1.1.11-gcc10.patch

BuildRequires: perl-generators file-devel bzip2-devel
BuildRequires: gcc cmake libcap-devel zlib-devel perl-interpreter

%description
cdrkit is a collection of CD/DVD utilities.

%package -n wodim
Summary: A command line CD/DVD recording program
Requires: libusal = %{version}-%{release}
Requires(preun): %{_sbindir}/alternatives coreutils
Requires(post): %{_sbindir}/alternatives coreutils

%description -n wodim
Wodim is an application for creating audio and data CDs. Wodim
works with many different brands of CD recorders, fully supports
multi-sessions and provides human-readable error messages.

%package -n genisoimage
Summary: Creates an image of an ISO9660 file-system
Requires: libusal = %{version}-%{release}
Requires(preun): %{_sbindir}/alternatives coreutils
Requires(post): %{_sbindir}/alternatives coreutils

%description -n genisoimage
The genisoimage program is used as a pre-mastering program; i.e., it
generates the ISO9660 file-system. Genisoimage takes a snapshot of
a given directory tree and generates a binary image of the tree
which will correspond to an ISO9660 file-system when written to
a block device. Genisoimage is used for writing CD-ROMs, and includes
support for creating boot-able El Torito CD-ROMs.

Install the genisoimage package if you need a program for writing
CD-ROMs.

%package -n dirsplit
Summary: Utility to split directories
Requires: perl-interpreter >= 5.8.1
Requires: genisoimage = %{version}-%{release}

%description -n dirsplit
This utility is used to split directories into chunks before burning. 
Chunk size is usually set to fit to a CD/DVD.

%package -n icedax
Summary: A utility for sampling/copying .wav files from digital audio CDs
Requires: libusal = %{version}-%{release}
Requires(preun): %{_sbindir}/alternatives coreutils
Requires(post): %{_sbindir}/alternatives coreutils
Requires: vorbis-tools
Requires: cdparanoia
BuildRequires: cdparanoia-devel

%description -n icedax
Icedax is a sampling utility for CD-ROM drives that are capable of
providing a CD's audio data in digital form to your host. Audio data
read from the CD can be saved as .wav or .sun format sound files.
Recording formats include stereo/mono, 8/12/16 bits and different
rates. Icedax can also be used as a CD player.

%package -n libusal
Summary: Library to communicate with SCSI devices

%description -n libusal
The libusal package contains C libraries that allows applications
to communicate with SCSI devices and is well suitable for writing
CD-R media.

%package -n libusal-devel
Summary: Development files for libusal
Requires: libusal = %{version}-%{release}

%description -n libusal-devel
The libusal-devel package contains C libraries and header files
for developing applications that use libusal for communication with
SCSI devices.

%prep
%autosetup -p1

rm -rf libparanoia

find . -type f -print0 | xargs -0 perl -pi -e 's#/usr/local/bin/perl#/usr/bin/perl#g'
find doc -type f -print0 | xargs -0 chmod a-x 


%build
export CFLAGS="$RPM_OPT_FLAGS -Wno-error=format-security -fno-strict-aliasing"
export CXXFLAGS="$CFLAGS"
export FFLAGS="$CFLAGS"

%cmake \
	-DCMAKE_INSTALL_PREFIX:PATH=%{_prefix} \
	-DBUILD_SHARED_LIBS:BOOL=ON

%cmake_build

%install
%cmake_install
perl -pi -e 's#^require v5.8.1;##g' %{buildroot}%{_bindir}/dirsplit
ln -s genisoimage %{buildroot}%{_bindir}/mkisofs
ln -s genisoimage %{buildroot}%{_bindir}/mkhybrid
ln -s icedax %{buildroot}%{_bindir}/cdda2wav
ln -s wodim %{buildroot}%{_bindir}/cdrecord
ln -s wodim %{buildroot}%{_bindir}/dvdrecord

ln -sf wodim.1.gz %{buildroot}/%{_mandir}/man1/netscsid.1.gz

rm %{buildroot}%{_bindir}/cdda2mp3

%post -n wodim
link=`readlink %{_bindir}/cdrecord`
if [ "$link" == "%{_bindir}/wodim" ]; then
	rm -f %{_bindir}/cdrecord
fi
link=`readlink %{_bindir}/dvdrecord`
if [ "$link" == "wodim" ]; then
	rm -f %{_bindir}/dvdrecord
fi

%{_sbindir}/alternatives --install %{_bindir}/cdrecord cdrecord \
		%{_bindir}/wodim 50 \
	--slave %{_mandir}/man1/cdrecord.1.gz cdrecord-cdrecordman \
		%{_mandir}/man1/wodim.1.gz \
	--slave %{_bindir}/dvdrecord cdrecord-dvdrecord %{_bindir}/wodim \
	--slave %{_mandir}/man1/dvdrecord.1.gz cdrecord-dvdrecordman \
		%{_mandir}/man1/wodim.1.gz \
	--slave %{_bindir}/readcd cdrecord-readcd %{_bindir}/readom \
	--slave %{_mandir}/man1/readcd.1.gz cdrecord-readcdman \
		%{_mandir}/man1/readom.1.gz 

%preun -n wodim
if [ $1 = 0 ]; then
	%{_sbindir}/alternatives --remove cdrecord %{_bindir}/wodim
fi

%post -n genisoimage
link=`readlink %{_bindir}/mkisofs`
if [ "$link" == "genisoimage" ]; then
	rm -f %{_bindir}/mkisofs
fi

%{_sbindir}/alternatives --install %{_bindir}/mkisofs mkisofs \
		%{_bindir}/genisoimage 50 \
	--slave %{_mandir}/man1/mkisofs.1.gz mkisofs-mkisofsman \
		%{_mandir}/man1/genisoimage.1.gz \
	--slave %{_bindir}/mkhybrid mkisofs-mkhybrid %{_bindir}/genisoimage \
	--slave %{_mandir}/man1/mkhybrid.1.gz mkisofs-mkhybridman \
		%{_mandir}/man1/genisoimage.1.gz

%preun -n genisoimage
if [ $1 = 0 ]; then
	%{_sbindir}/alternatives --remove mkisofs %{_bindir}/genisoimage
fi

%post -n icedax
link=`readlink %{_bindir}/cdda2wav`
if [ "$link" == "icedax" ]; then
	rm -f %{_bindir}/cdda2wav
fi
%{_sbindir}/alternatives --install %{_bindir}/cdda2wav cdda2wav \
		%{_bindir}/icedax 50 \
	--slave %{_mandir}/man1/cdda2wav.1.gz cdda2wav-cdda2wavman \
		%{_mandir}/man1/icedax.1.gz 

%preun -n icedax
if [ $1 = 0 ]; then
	%{_sbindir}/alternatives --remove cdda2wav %{_bindir}/icedax
fi


%files -n wodim
%license COPYING
%doc Changelog FAQ FORK START
%doc doc/READMEs doc/wodim
%{_bindir}/devdump
%{_bindir}/wodim
%ghost %{_bindir}/cdrecord
%ghost %{_bindir}/dvdrecord
%{_bindir}/readom
%{_sbindir}/netscsid
%{_mandir}/man1/devdump.*
%{_mandir}/man1/wodim.*
%{_mandir}/man1/netscsid.*
%{_mandir}/man1/readom.*

%files -n icedax
%license COPYING
%doc doc/icedax
%{_bindir}/icedax
%ghost %{_bindir}/cdda2wav
%{_bindir}/cdda2ogg
%{_mandir}/man1/icedax.*
%{_mandir}/man1/cdda2ogg.*
%{_mandir}/man1/list_audio_tracks.*

%files -n genisoimage
%license COPYING
%doc doc/genisoimage
%{_bindir}/genisoimage
%ghost %{_bindir}/mkisofs
%ghost %{_bindir}/mkhybrid
%{_bindir}/isodebug
%{_bindir}/isodump
%{_bindir}/isoinfo
%{_bindir}/isovfy
%{_bindir}/pitchplay
%{_bindir}/readmult
%{_mandir}/man5/genisoimagerc.*
%{_mandir}/man1/genisoimage.*
%{_mandir}/man1/isodebug.*
%{_mandir}/man1/isodump.*
%{_mandir}/man1/isoinfo.*
%{_mandir}/man1/isovfy.*
%{_mandir}/man1/pitchplay.*
%{_mandir}/man1/readmult.*

%files -n dirsplit
%license COPYING
%{_bindir}/dirsplit
%{_mandir}/man1/dirsplit.*

%files -n libusal
%license COPYING
%doc doc/plattforms/README.linux Changelog FAQ FORK START
%{_libdir}/libusal.so.*
%{_libdir}/librols.so.*

%files -n libusal-devel
%license COPYING
%{_libdir}/libusal.so
%{_libdir}/librols.so
%{_includedir}/usal

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.11-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.11-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 04 2023 Xiaojie Chen <jackxjchen@tencent.com> - 1.1.11-3
- Rebuilt for file 5.45

* Wed May 24 2023 Shuo Wang <abushwang@tencent.com> - 1.1.11-2
- update url

* Fri Mar 17 2023 cunshunxia <cunshunxia@tencent.com> - 1.1.11-1
- initial build
